(* Read words are stored in letters separated by '\000' *)
let maxlength = 1024 * 1024 * 15
let letters = String.make maxlength '\000'
let input_index = ref 0
let push_letter c =
  letters.[!input_index] <- c;
  incr input_index
let close_word () =
  incr input_index (* = insert a \000 *)
let reopen_word () =
  decr input_index

let output_index = ref 0
let restart_letters_table () = output_index := 0
let rec output_next_letters () =
  let c = letters.[!output_index] in
  incr output_index;
  if c <> '\000' then (print_char c; output_next_letters ())

